/*
** Mixer.h for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Thu Mar 11 16:32:15 1999 Rmi Coupet
** Last update Fri Mar 12 22:17:16 1999 Rmi Coupet
*/


#ifndef __MIXER_H__

#define __MIXER_H__
#include "gtk/gtk.h"
#include "ConfigLib.h"
#include "MixerTypes.h"
#include "Parse_Filter_Conf.h"
#include "mixer_list.h"
#include "Win_Aux.h"
#include "gui.h"

#include "MixerKernel.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define MIXER(obj)          GTK_CHECK_CAST (obj, mixer_get_type (), Mixer)
#define MIXERCLASS(klass)  GTK_CHECK_CLASS_CAST (klass, mixer_get_type (), \
						       MixerClass) 
#define IS_MIXER(obj)       GTK_CHECK_TYPE (obj, mixer_get_type ())

typedef struct _Mixer			Mixer ;
typedef struct _MixerClass		MixerClass ;

struct		_Mixer
{
  GtkVBox	VBox; /* type of the ancestor */
  
  GtkWidget	*scrolled_window ;
  GtkWidget	*menubar ;
  GtkWidget	*import_button ;
  GtkWidget	*volume_hscale ;
  GtkWidget	*progress_bar ;
  GtkWidget	*frame ;
  GtkWidget	*vbox ;
  GtkWidget	*hscrollbar ;
  GtkWidget	*play_button ;
  GtkWidget	*pause_button ;
  GtkWidget	*stop_button ;
  t_gmurfrc	*gmurfrc ;
  t_main_mixer	*Main_Mixer ;
  t_filters	*filters ;
  t_ms_list	*ms_list ;
  int		stop ;
  int		nb_ms ;
  size_t	max_size ;
} ;

struct		_MixerClass
{
  GtkVBoxClass	parent_class;

  void		(* mixer) (Mixer *mg);
};

guint		mixer_get_type			(void);
GtkWidget*	mixer_new			(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __MIXER_H__ */












