/*
** mix_sample.h for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Wed Mar 10 22:35:52 1999 Rmi Coupet
** Last update Thu Mar 18 13:13:00 1999 Rmi Coupet
*/


#ifndef __MIX_SAMPLE_H__

#define __MIX_SAMPLE_H__
#include "gtk/gtk.h"
#include "Win_Aux.h"
#include "gui.h"
#include "TempGmurf.h"
#include "ConfigLib.h"
#include "Constants.h"
#include <stdlib.h>
#include "MixerProtos.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define MIXER_WIDTH 560

#define MIX_SAMPLE(obj)          GTK_CHECK_CAST (obj, mix_sample_get_type (), Mixer_Sample)
#define MIX_SAMPLE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, mix_sample_get_type (), \
						       Mixer_SampleClass) 
#define IS_MIX_SAMPLE(obj)       GTK_CHECK_TYPE (obj, mix_sample_get_type ())

#define MIX_SAMPLE_WIDTH 250 
#define MIX_SAMPLE_HEIGHT 50 
#define MAX_32BITS 0x7fffffff 
  
typedef struct _Mixer_Sample		Mixer_Sample ;
typedef struct _Mixer_SampleClass	Mixer_SampleClass ;

struct		_Mixer_Sample
{
  GtkVBox	vbox; /* type of the ancestor */
  
  GtkWidget	*DrawingArea ;
  GdkPixmap	*pixmap ;
  GtkWidget	*entry_date ;
  GtkWidget	*play_toggle ;
  GtkWidget	*rec_toggle ;
  GtkWidget	*combo ;
  GtkWidget	*close_button ;
  GtkWidget	*mute_button ;
  GtkWidget	*freq_button ;
  GtkWidget	*frame ;
  GtkWidget	*volume_hscale ;
  GtkWidget	*balance_hscale ;
  GtkWidget	*WE_button ;
  t_tempgmurf	*tempgmurf ;
  t_mixer_elt	*elt ;
  size_t	begin ;
};

struct		_Mixer_SampleClass
{
  GtkVBoxClass	parent_class;

  void		(* mix_sample) (Mixer_Sample *ms);
};

guint		mix_sample_get_type	(void);
GtkWidget*	mix_sample_new		(void);
void 		ms_draw_wav		(Mixer_Sample 		*ms) ;
void		close_ms		(GtkWidget	*widget) ;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __MIXER_SAMPLE_H__ */













