/*
** mixer_launch.c for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Thu Mar 11 23:13:30 1999 Rmi Coupet
** Last update Fri Mar 19 12:12:15 1999 Rmi Coupet
*/

#include "mixer_launch.h"
#include "stdio.h"


void		export_to_WE	(GtkWidget	*widget) ;
void		int_entry	(GtkWidget	*widget,
				 gpointer	data) ;				

void		export_to_WE(widget)
GtkWidget	*widget ;
{
  if ( (MIX_SAMPLE(widget)->tempgmurf->temp_size != 0)
       && (MIX_SAMPLE(widget)->tempgmurf->connected == IN_MIXER) )
  {
    MIX_SAMPLE(widget)->tempgmurf->connected = IN_BOTH ;
    connect_with_wav_editor(MIX_SAMPLE(widget)->tempgmurf, MIX_SAMPLE(widget)) ;
  }
}


GtkWidget *Create_Mixer()
{
  GtkWidget	*mg ;
  
  mg = mixer_new() ;
  gtk_widget_set_name(mg, "mixer"); 
  MIXER (mg)->menubar = create_root_menu_bar() ;
  gtk_container_add(GTK_CONTAINER (MIXER (mg)->frame), MIXER (mg)->menubar);
  gtk_widget_show(mg) ;  
  return mg ;
}

GtkWidget	*Create_mix_sample(gmurf) 
t_tempgmurf	*gmurf ;
{
  GtkWidget	*ms ;
  t_dsprc       *dsprc;
  t_dsp         *dsp;
  t_mixer_info	*mixer_info ;
  t_mixer_elt	*mixer_elt ;
  t_ms_list	*ms_list ;

  mixer_info = new_mixer_info(DEFAULT_VOLUME,
				/*MIXER (Global_Mixer)->gmurfrc->first_dsp->sample_rate*/0,
			      DEFAULT_PANNING, DEFAULT_DATE);

  dsprc = MIXER (Global_Mixer)->gmurfrc->first_dsp;
  dsp   = dsprc->dsp;

  mixer_elt = add_mixer_elt(MIXER (Global_Mixer)->Main_Mixer,
			    MIXER (Global_Mixer)->gmurfrc->first_dsp_in_list , 
			    gmurf, mixer_info) ;

  
  MIXER(Global_Mixer)->max_size = 
    (gmurf->temp_size / 4 > MIXER(Global_Mixer)->max_size ? 
     gmurf->temp_size / 4 : MIXER(Global_Mixer)->max_size ) ;

  ms = mix_sample_new() ;
  MIX_SAMPLE(ms)->elt = mixer_elt ;
  MIX_SAMPLE(ms)->tempgmurf = gmurf ;
  gtk_frame_set_label(GTK_FRAME (MIX_SAMPLE(ms)->frame), gmurf->origname);
  gtk_widget_show(ms) ;
  gtk_box_pack_start(GTK_BOX(MIXER(Global_Mixer)->vbox), ms, FALSE, FALSE, 0);

  gtk_signal_connect_object(GTK_OBJECT(MIX_SAMPLE(ms)->WE_button), "clicked",
			    GTK_SIGNAL_FUNC(export_to_WE), GTK_OBJECT(ms));
  gtk_signal_connect(GTK_OBJECT(MIX_SAMPLE(ms)->entry_date), "changed",
		     GTK_SIGNAL_FUNC(int_entry), (gpointer) ms);

  /* Mixer_Sample List */
  ms_list = (t_ms_list *) malloc(sizeof (t_ms_list)) ;
  ms_list->ms = MIX_SAMPLE (ms) ;
  ms_list->next = MIXER(Global_Mixer)->ms_list ;
  MIXER(Global_Mixer)->ms_list = ms_list ;
  MIXER(Global_Mixer)->nb_ms += 1 ;
  return ms ;
}


void		Open_mix_sample(gmurf, mix_elt) 
t_tempgmurf	*gmurf ;
t_mixer_elt	*mix_elt ;
{
  GtkWidget	*ms ;
  t_ms_list	*ms_list ;
  GtkAdjustment	*adj ;

  gmurf->connected = IN_MIXER ;

  MIXER(Global_Mixer)->max_size = 
    (gmurf->temp_size / 4 > MIXER(Global_Mixer)->max_size ? 
     gmurf->temp_size / 4 : MIXER(Global_Mixer)->max_size ) ;

  ms = mix_sample_new() ;
  MIX_SAMPLE(ms)->elt = mix_elt ;
  MIX_SAMPLE(ms)->tempgmurf = gmurf ;
  
  /*begin */
  gtk_entry_set_text(GTK_ENTRY (MIX_SAMPLE(ms)->entry_date), 
		     itoa(mix_elt->mixer_info->begin_date));
  MIX_SAMPLE(ms)->begin = mix_elt->mixer_info->begin_date ;
  /* Record */
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (MIX_SAMPLE(ms)->play_toggle), 
			       mix_elt->rec_or_play);
  /* Mute */
//  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (MIX_SAMPLE(ms)->mute_button), 
  //		       mix_elt->mute);
  /* Freq Curve */
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (MIX_SAMPLE(ms)->freq_button), 
			       mix_elt->mixer_info->do_freq);
  //  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(ms->combo)->entry), "AWE 32");


  adj = gtk_range_get_adjustment(GTK_RANGE (MIX_SAMPLE(ms)->volume_hscale)) ;
  adj->upper = 30 ;
  adj->lower = 0 ;
  adj->value = mix_elt->mixer_info->volume * 10;
  adj->page_increment = 1 ;
  adj->page_size = 2 ;
  adj->step_increment = 1 ;
  gtk_range_set_adjustment(GTK_RANGE (MIX_SAMPLE(ms)->volume_hscale), adj) ;

  adj = gtk_range_get_adjustment(GTK_RANGE (MIX_SAMPLE(ms)->balance_hscale)) ;
  adj->upper = 10 ;
  adj->lower = -10 ;
  printf("bal : %f\n", mix_elt->mixer_info->panning) ;
  
  adj->value = (mix_elt->mixer_info->panning * 20.0) - 10 ;
  adj->page_increment = 1 ;
  adj->page_size = 2 ;
  adj->step_increment = 1 ;
  gtk_range_set_adjustment(GTK_RANGE (MIX_SAMPLE(ms)->balance_hscale), adj) ;

  gtk_frame_set_label(GTK_FRAME (MIX_SAMPLE(ms)->frame), gmurf->origname);
  gtk_widget_show(ms) ;
  gtk_box_pack_start(GTK_BOX(MIXER(Global_Mixer)->vbox), ms, FALSE, FALSE, 0);

  gtk_signal_connect_object(GTK_OBJECT(MIX_SAMPLE(ms)->WE_button), "clicked",
			    GTK_SIGNAL_FUNC(export_to_WE), GTK_OBJECT(ms));
  gtk_signal_connect(GTK_OBJECT(MIX_SAMPLE(ms)->entry_date), "changed",
		     GTK_SIGNAL_FUNC(int_entry), (gpointer) ms);

  /* Mixer_Sample List */
  ms_list = (t_ms_list *) malloc(sizeof (t_ms_list)) ;
  ms_list->ms = MIX_SAMPLE (ms) ;
  ms_list->next = MIXER(Global_Mixer)->ms_list ;
  MIXER(Global_Mixer)->ms_list = ms_list ;
  MIXER(Global_Mixer)->nb_ms += 1 ;
}


void		int_entry(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  GtkEntry		*entry ;
  char			*str ;
  size_t 		begin ;
  Mixer_Sample		*ms ;
  t_ms_list		*tmp ;
  int			change = FALSE ;
  int 			i ;

  ms = MIX_SAMPLE (data) ;
  entry = GTK_ENTRY (widget) ;
  str = gtk_entry_get_text(entry) ;
  begin = atol(str) ;
  if (begin > 0)
  {
    if (ms->begin > begin)
    {
      if (ms->begin + ms->tempgmurf->temp_size / 4 >= MIXER (Global_Mixer)->max_size)
      {
	size_t	bigger ;
	
	ms->begin = begin ;
	bigger = ms->begin + ms->tempgmurf->temp_size / 4 ;
	tmp = MIXER(Global_Mixer)->ms_list ;
	for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
	{
	  if (bigger < tmp->ms->begin + tmp->ms->tempgmurf->temp_size / 4)
	    bigger = tmp->ms->begin + tmp->ms->tempgmurf->temp_size / 4 ;
	  tmp = tmp->next ;
	}
	MIXER (Global_Mixer)->max_size = bigger ;
	change = TRUE ;
      } else 
      {
	ms->begin = begin ;
      }
    }
    else
    {
      ms->begin = begin ;
      tmp = MIXER(Global_Mixer)->ms_list ;
      for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
      {
	if (tmp->ms->begin + tmp->ms->tempgmurf->temp_size / 4 > 
	    MIXER (Global_Mixer)->max_size)
	{
	  MIXER (Global_Mixer)->max_size = tmp->ms->begin + 
	    tmp->ms->tempgmurf->temp_size / 4 ;
	  change = TRUE ;
	}
	tmp = tmp->next ;
      }
    }
    if (change)
    {
      tmp = MIXER(Global_Mixer)->ms_list ;
      for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
	{
	  ms_draw_wav(tmp->ms) ;
	  tmp = tmp->next ;
	}
    }
    else
      ms_draw_wav(ms) ;
  }
  ms->elt->mixer_info->begin_date = ms->begin ;
}




















